diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user.c gdm-2.28.2/gui/simple-greeter/gdm-user.c
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user.c	2010-01-22 11:17:50.731384714 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user.c	2010-01-24 01:19:38.803538369 -0500
@@ -1,24 +1,27 @@
 /* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
- *
- * Copyright (C) 2004-2005 James M. Cape <jcape@ignore-your.tv>.
- * Copyright (C) 2007-2008 William Jon McCann <mccann@jhu.edu>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- */
+  *
+  * Copyright (C) 2004-2005 James M. Cape <jcape@ignore-your.tv>.
+  * Copyright (C) 2007-2008 William Jon McCann <mccann@jhu.edu>
+  * Copyright (C) 2009 Red Hat, Inc.
+  *
+  * This program is free software; you can redistribute it and/or modify
+  * it under the terms of the GNU General Public License as published by
+  * the Free Software Foundation; either version 2 of the License, or
+  * (at your option) any later version.
+  *
+  * This program is distributed in the hope that it will be useful,
+  * but WITHOUT ANY WARRANTY; without even the implied warranty of
+  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  * GNU General Public License for more details.
+  *
+  * You should have received a copy of the GNU General Public License
+  * along with this program; if not, write to the Free Software
+  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+  */
 
-#include <config.h>
+#define _XOPEN_SOURCE
+
+#include "config.h"
 
 #include <float.h>
 #include <string.h>
@@ -26,207 +29,179 @@
 #include <sys/stat.h>
 #include <unistd.h>
 
+#include <glib.h>
 #include <glib/gi18n.h>
 #include <gio/gio.h>
 #include <gtk/gtk.h>
 
-#include "gdm-user-manager.h"
-#include "gdm-user-private.h"
+#include <dbus/dbus-glib.h>
+
+#include "gdm-user.h"
 
-#define GDM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GDM_TYPE_USER, GdmUserClass))
-#define GDM_IS_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GDM_TYPE_USER))
+ #define GDM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GDM_TYPE_USER, GdmUserClass))
+ #define GDM_IS_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GDM_TYPE_USER))
 #define GDM_USER_GET_CLASS(object) (G_TYPE_INSTANCE_GET_CLASS ((object), GDM_TYPE_USER, GdmUserClass))
 
-#define GLOBAL_FACEDIR    DATADIR "/faces"
-#define MAX_ICON_SIZE     128
 #define MAX_FILE_SIZE     65536
-#define MINIMAL_UID       100
-
-enum {
-        PROP_0,
-        PROP_MANAGER,
-        PROP_REAL_NAME,
-        PROP_DISPLAY_NAME,
-        PROP_USER_NAME,
-        PROP_UID,
-        PROP_HOME_DIR,
-        PROP_SHELL,
-        PROP_LOGIN_FREQUENCY,
-};
-
-enum {
-        ICON_CHANGED,
-        SESSIONS_CHANGED,
-        LAST_SIGNAL
-};
-
-struct _GdmUser {
-        GObject         parent;
-
-        GdmUserManager *manager;
 
+typedef struct {
         uid_t           uid;
-        char           *user_name;
-        char           *real_name;
-        char           *display_name;
-        char           *home_dir;
-        char           *shell;
-        GList          *sessions;
-        gulong          login_frequency;
-
-        GFileMonitor   *icon_monitor;
-};
+        gchar          *user_name;
+        gchar          *real_name;
+        gint            account_type;
+        gint            password_mode;
+        gchar          *password_hint;
+        gchar          *email;
+        gchar          *language;
+        gchar          *location;
+        guint64         login_frequency;
+        gchar          *icon_file;
+        gboolean        locked;
+        gboolean        automatic_login;
+} UserProperties;
 
-typedef struct _GdmUserClass
+static void
+collect_props (const gchar    *key,
+               const GValue   *value,
+               UserProperties *props)
 {
-        GObjectClass parent_class;
-
-        void (* icon_changed)     (GdmUser *user);
-        void (* sessions_changed) (GdmUser *user);
-} GdmUserClass;
-
-static void gdm_user_finalize     (GObject      *object);
-
-static guint signals[LAST_SIGNAL] = { 0 };
-
-G_DEFINE_TYPE (GdmUser, gdm_user, G_TYPE_OBJECT)
+        gboolean handled = TRUE;
 
-static int
-session_compare (const char *a,
-                 const char *b)
-{
-        if (a == NULL) {
-                return 1;
-        } else if (b == NULL) {
-                return -1;
+        if (strcmp (key, "Uid") == 0) {
+                props->uid = g_value_get_uint64 (value);
+        }
+        else if (strcmp (key, "UserName") == 0) {
+                props->user_name = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "RealName") == 0) {
+                props->real_name = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "AccountType") == 0) {
+                props->account_type = g_value_get_int (value);
+        }
+        else if (strcmp (key, "Email") == 0) {
+                props->email = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "Language") == 0) {
+                props->language = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "Location") == 0) {
+                props->location = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "LoginFrequency") == 0) {
+                props->login_frequency = g_value_get_uint64 (value);
+        }
+        else if (strcmp (key, "IconFile") == 0) {
+                props->icon_file = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "Locked") == 0) {
+                props->locked = g_value_get_boolean (value);
+        }
+        else if (strcmp (key, "AutomaticLogin") == 0) {
+                props->automatic_login = g_value_get_boolean (value);
+        }
+        else if (strcmp (key, "PasswordMode") == 0) {
+                props->password_mode = g_value_get_int (value);
+        }
+        else if (strcmp (key, "PasswordHint") == 0) {
+                props->password_hint = g_value_dup_string (value);
+        }
+        else if (strcmp (key, "HomeDirectory") == 0) {
+                /* ignore */
+        }
+        else if (strcmp (key, "Shell") == 0) {
+                /* ignore */
+        }
+        else {
+                handled = FALSE;
         }
 
-        return strcmp (a, b);
+        if (!handled)
+                g_debug ("unhandled property %s", key);
 }
 
-void
-_gdm_user_add_session (GdmUser    *user,
-                       const char *ssid)
+static void
+user_properties_free (UserProperties *props)
 {
-        GList *li;
-
-        g_return_if_fail (GDM_IS_USER (user));
-        g_return_if_fail (ssid != NULL);
-
-        li = g_list_find_custom (user->sessions, ssid, (GCompareFunc)session_compare);
-        if (li == NULL) {
-                g_debug ("GdmUser: adding session %s", ssid);
-                user->sessions = g_list_prepend (user->sessions, g_strdup (ssid));
-                g_signal_emit (user, signals[SESSIONS_CHANGED], 0);
-        } else {
-                g_debug ("GdmUser: session already present: %s", ssid);
-        }
+        g_free (props->user_name);
+        g_free (props->real_name);
+        g_free (props->password_hint);
+        g_free (props->email);
+        g_free (props->language);
+        g_free (props->location);
+        g_free (props->icon_file);
+        g_free (props);
 }
 
-void
-_gdm_user_remove_session (GdmUser    *user,
-                          const char *ssid)
+static UserProperties *
+user_properties_get (DBusGConnection *bus,
+                     const gchar     *object_path)
 {
-        GList *li;
+        UserProperties *props;
+        GError *error;
+        DBusGProxy *proxy;
+        GHashTable *hash_table;
 
-        g_return_if_fail (GDM_IS_USER (user));
-        g_return_if_fail (ssid != NULL);
+        props = g_new0 (UserProperties, 1);
 
-        li = g_list_find_custom (user->sessions, ssid, (GCompareFunc)session_compare);
-        if (li != NULL) {
-                g_debug ("GdmUser: removing session %s", ssid);
-                g_free (li->data);
-                user->sessions = g_list_delete_link (user->sessions, li);
-                g_signal_emit (user, signals[SESSIONS_CHANGED], 0);
-        } else {
-                g_debug ("GdmUser: session not found: %s", ssid);
+        proxy = dbus_g_proxy_new_for_name (bus,
+                                           "org.freedesktop.Accounts",
+                                           object_path,
+                                           "org.freedesktop.DBus.Properties");
+        error = NULL;
+        if (!dbus_g_proxy_call (proxy,
+                                "GetAll",
+                                &error,
+                                G_TYPE_STRING,
+                                "org.freedesktop.Accounts.User",
+                                G_TYPE_INVALID,
+                                dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE),
+                                &hash_table,
+                                G_TYPE_INVALID)) {
+                g_debug ("Error calling GetAll() when retrieving properties for %s: %s", object_path, error->message);
+                g_error_free (error);
+                g_free (props);
+                props = NULL;
+                goto out;
         }
-}
+        g_hash_table_foreach (hash_table, (GHFunc) collect_props, props);
+        g_hash_table_unref (hash_table);
 
-guint
-gdm_user_get_num_sessions (GdmUser    *user)
-{
-        return g_list_length (user->sessions);
+ out:
+        g_object_unref (proxy);
+        return props;
 }
 
-GList *
-gdm_user_get_sessions (GdmUser *user)
-{
-        return user->sessions;
-}
 
-static void
-_gdm_user_set_login_frequency (GdmUser *user,
-                               gulong   login_frequency)
-{
-        user->login_frequency = login_frequency;
-        g_object_notify (G_OBJECT (user), "login-frequency");
-}
+struct _GdmUser {
+        GObject         parent;
 
-static void
-gdm_user_set_property (GObject      *object,
-                       guint         param_id,
-                       const GValue *value,
-                       GParamSpec   *pspec)
-{
-        GdmUser *user;
+        DBusGConnection *bus;
+        DBusGProxy      *proxy;
+        gchar           *object_path;
 
-        user = GDM_USER (object);
+        UserProperties  *props;
+        GList           *sessions;
 
-        switch (param_id) {
-        case PROP_MANAGER:
-                user->manager = g_value_get_object (value);
-                g_assert (user->manager);
-                break;
-        case PROP_LOGIN_FREQUENCY:
-                _gdm_user_set_login_frequency (user, g_value_get_ulong (value));
-                break;
-        default:
-                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
-                break;
-        }
-}
+        gchar           *display_name;
+};
 
-static void
-gdm_user_get_property (GObject    *object,
-                       guint       param_id,
-                       GValue     *value,
-                       GParamSpec *pspec)
+typedef struct _GdmUserClass
 {
-        GdmUser *user;
+        GObjectClass parent_class;
+} GdmUserClass;
 
-        user = GDM_USER (object);
+enum {
+        CHANGED,
+        SESSIONS_CHANGED,
+        LAST_SIGNAL
+};
 
-        switch (param_id) {
-        case PROP_MANAGER:
-                g_value_set_object (value, user->manager);
-                break;
-        case PROP_USER_NAME:
-                g_value_set_string (value, user->user_name);
-                break;
-        case PROP_REAL_NAME:
-                g_value_set_string (value, user->real_name);
-                break;
-        case PROP_DISPLAY_NAME:
-                g_value_set_string (value, user->display_name);
-                break;
-        case PROP_HOME_DIR:
-                g_value_set_string (value, user->home_dir);
-                break;
-        case PROP_UID:
-                g_value_set_ulong (value, user->uid);
-                break;
-        case PROP_SHELL:
-                g_value_set_string (value, user->shell);
-                break;
-        case PROP_LOGIN_FREQUENCY:
-                g_value_set_ulong (value, user->login_frequency);
-                break;
-        default:
-                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
-                break;
-        }
-}
+static guint signals[LAST_SIGNAL] = { 0 };
+
+static void gdm_user_finalize (GObject *object);
+
+G_DEFINE_TYPE (GdmUser, gdm_user, G_TYPE_OBJECT)
 
 static void
 gdm_user_class_init (GdmUserClass *class)
@@ -235,86 +210,20 @@
 
         gobject_class = G_OBJECT_CLASS (class);
 
-        gobject_class->set_property = gdm_user_set_property;
-        gobject_class->get_property = gdm_user_get_property;
         gobject_class->finalize = gdm_user_finalize;
 
-        g_object_class_install_property (gobject_class,
-                                         PROP_MANAGER,
-                                         g_param_spec_object ("manager",
-                                                              _("Manager"),
-                                                              _("The user manager object this user is controlled by."),
-                                                              GDM_TYPE_USER_MANAGER,
-                                                              (G_PARAM_READWRITE |
-                                                               G_PARAM_CONSTRUCT_ONLY)));
-
-        g_object_class_install_property (gobject_class,
-                                         PROP_REAL_NAME,
-                                         g_param_spec_string ("real-name",
-                                                              "Real Name",
-                                                              "The real name to display for this user.",
-                                                              NULL,
-                                                              G_PARAM_READABLE));
-
-        g_object_class_install_property (gobject_class,
-                                         PROP_DISPLAY_NAME,
-                                         g_param_spec_string ("display-name",
-                                                              "Display Name",
-                                                              "The unique name to display for this user.",
-                                                              NULL,
-                                                              G_PARAM_READABLE));
-
-        g_object_class_install_property (gobject_class,
-                                         PROP_UID,
-                                         g_param_spec_ulong ("uid",
-                                                             "User ID",
-                                                             "The UID for this user.",
-                                                             0, G_MAXULONG, 0,
-                                                             G_PARAM_READABLE));
-        g_object_class_install_property (gobject_class,
-                                         PROP_USER_NAME,
-                                         g_param_spec_string ("user-name",
-                                                              "User Name",
-                                                              "The login name for this user.",
-                                                              NULL,
-                                                              G_PARAM_READABLE));
-        g_object_class_install_property (gobject_class,
-                                         PROP_HOME_DIR,
-                                         g_param_spec_string ("home-directory",
-                                                              "Home Directory",
-                                                              "The home directory for this user.",
-                                                              NULL,
-                                                              G_PARAM_READABLE));
-        g_object_class_install_property (gobject_class,
-                                         PROP_SHELL,
-                                         g_param_spec_string ("shell",
-                                                              "Shell",
-                                                              "The shell for this user.",
-                                                              NULL,
-                                                              G_PARAM_READABLE));
-        g_object_class_install_property (gobject_class,
-                                         PROP_LOGIN_FREQUENCY,
-                                         g_param_spec_ulong ("login-frequency",
-                                                             "login frequency",
-                                                             "login frequency",
-                                                             0,
-                                                             G_MAXULONG,
-                                                             0,
-                                                             G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-        signals [ICON_CHANGED] =
-                g_signal_new ("icon-changed",
-                              G_TYPE_FROM_CLASS (class),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserClass, icon_changed),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__VOID,
-                              G_TYPE_NONE, 0);
+        signals[CHANGED] = g_signal_new ("changed",
+                                         G_TYPE_FROM_CLASS (class),
+                                         G_SIGNAL_RUN_LAST,
+                                         0,
+                                         NULL, NULL,
+                                         g_cclosure_marshal_VOID__VOID,
+                                         G_TYPE_NONE, 0);
         signals [SESSIONS_CHANGED] =
                 g_signal_new ("sessions-changed",
                               G_TYPE_FROM_CLASS (class),
                               G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserClass, sessions_changed),
+                              0,
                               NULL, NULL,
                               g_cclosure_marshal_VOID__VOID,
                               G_TYPE_NONE, 0);
@@ -322,67 +231,8 @@
 
 
 static void
-on_icon_monitor_changed (GFileMonitor     *monitor,
-                         GFile            *file,
-                         GFile            *other_file,
-                         GFileMonitorEvent event_type,
-                         GdmUser          *user)
-{
-        g_debug ("Icon changed: %d", event_type);
-
-        if (event_type != G_FILE_MONITOR_EVENT_CHANGED &&
-            event_type != G_FILE_MONITOR_EVENT_CREATED) {
-                return;
-        }
-
-        _gdm_user_icon_changed (user);
-}
-
-static void
-update_icon_monitor (GdmUser *user)
-{
-        GFile  *file;
-        GError *error;
-        char   *path;
-
-        if (user->home_dir == NULL) {
-                return;
-        }
-
-        if (user->icon_monitor != NULL) {
-                g_file_monitor_cancel (user->icon_monitor);
-                user->icon_monitor = NULL;
-        }
-
-        path = g_build_filename (user->home_dir, ".face", NULL);
-        g_debug ("adding monitor for '%s'", path);
-        file = g_file_new_for_path (path);
-        error = NULL;
-        user->icon_monitor = g_file_monitor_file (file,
-                                                  G_FILE_MONITOR_NONE,
-                                                  NULL,
-                                                  &error);
-        if (user->icon_monitor != NULL) {
-                g_signal_connect (user->icon_monitor,
-                                  "changed",
-                                  G_CALLBACK (on_icon_monitor_changed),
-                                  user);
-        } else {
-                g_warning ("Unable to monitor %s: %s", path, error->message);
-                g_error_free (error);
-        }
-        g_object_unref (file);
-        g_free (path);
-}
-
-static void
 gdm_user_init (GdmUser *user)
 {
-        user->manager = NULL;
-        user->user_name = NULL;
-        user->real_name = NULL;
-        user->display_name = NULL;
-        user->sessions = NULL;
 }
 
 static void
@@ -392,265 +242,59 @@
 
         user = GDM_USER (object);
 
-        g_file_monitor_cancel (user->icon_monitor);
-
-        g_free (user->user_name);
-        g_free (user->real_name);
-        g_free (user->display_name);
-
-        if (G_OBJECT_CLASS (gdm_user_parent_class)->finalize)
-                (*G_OBJECT_CLASS (gdm_user_parent_class)->finalize) (object);
-}
-
-/**
- * _gdm_user_update:
- * @user: the user object to update.
- * @pwent: the user data to use.
- *
- * Updates the properties of @user using the data in @pwent.
- *
- * Since: 1.0
- **/
-void
-_gdm_user_update (GdmUser             *user,
-                  const struct passwd *pwent)
-{
-        gchar *real_name = NULL;
-
-        g_return_if_fail (GDM_IS_USER (user));
-        g_return_if_fail (pwent != NULL);
-
-        g_object_freeze_notify (G_OBJECT (user));
+        dbus_g_connection_unref (user->bus);
+        g_free (user->object_path);
 
-        /* Display Name */
-        if (pwent->pw_gecos && pwent->pw_gecos[0] != '\0') {
-                gchar *first_comma = NULL;
-                gchar *valid_utf8_name = NULL;
-
-                if (g_utf8_validate (pwent->pw_gecos, -1, NULL)) {
-                        valid_utf8_name = pwent->pw_gecos;
-                        first_comma = g_utf8_strchr (valid_utf8_name, -1, ',');
-                } else {
-                        g_warning ("User %s has invalid UTF-8 in GECOS field. "
-                                   "It would be a good thing to check /etc/passwd.",
-                                   pwent->pw_name ? pwent->pw_name : "");
-                }
+        if (user->proxy != NULL)
+                g_object_unref (user->proxy);
 
-                if (first_comma) {
-                        real_name = g_strndup (valid_utf8_name,
-                                                  (first_comma - valid_utf8_name));
-                } else if (valid_utf8_name) {
-                        real_name = g_strdup (valid_utf8_name);
-                } else {
-                        real_name = NULL;
-                }
+        if (user->props != NULL)
+                user_properties_free (user->props);
 
-                if (real_name && real_name[0] == '\0') {
-                        g_free (real_name);
-                        real_name = NULL;
-                }
-        } else {
-                real_name = NULL;
-        }
-
-        if ((real_name && !user->real_name) ||
-            (!real_name && user->real_name) ||
-            (real_name &&
-             user->real_name &&
-             strcmp (real_name, user->real_name) != 0)) {
-                g_free (user->real_name);
-                user->real_name = real_name;
-                g_object_notify (G_OBJECT (user), "real-name");
-        } else {
-                g_free (real_name);
-        }
-
-        /* Unique Display Name */
-        if ((!user->real_name && user->display_name) ||
-            (user->real_name &&
-             user->display_name &&
-             strncmp (user->real_name, user->display_name, strlen (user->real_name)) != 0)) {
-                g_free (user->display_name);
-                user->display_name = NULL;
-                g_object_notify (G_OBJECT (user), "display-name");
-        }
-
-        /* UID */
-        if (pwent->pw_uid != user->uid) {
-                user->uid = pwent->pw_uid;
-                g_object_notify (G_OBJECT (user), "uid");
-        }
-
-        /* Username */
-        if ((pwent->pw_name && !user->user_name) ||
-            (!pwent->pw_name && user->user_name) ||
-            (pwent->pw_name &&
-             user->user_name &&
-             strcmp (user->user_name, pwent->pw_name) != 0)) {
-                g_free (user->user_name);
-                user->user_name = g_strdup (pwent->pw_name);
-                g_object_notify (G_OBJECT (user), "user-name");
-        }
-
-        /* Home Directory */
-        if ((pwent->pw_dir && !user->home_dir) ||
-            (!pwent->pw_dir && user->home_dir) ||
-            strcmp (user->home_dir, pwent->pw_dir) != 0) {
-                g_free (user->home_dir);
-                user->home_dir = g_strdup (pwent->pw_dir);
-                g_object_notify (G_OBJECT (user), "home-directory");
-                g_signal_emit (user, signals[ICON_CHANGED], 0);
-        }
-
-        /* Shell */
-        if ((pwent->pw_shell && !user->shell) ||
-            (!pwent->pw_shell && user->shell) ||
-            (pwent->pw_shell &&
-             user->shell &&
-             strcmp (user->shell, pwent->pw_shell) != 0)) {
-                g_free (user->shell);
-                user->shell = g_strdup (pwent->pw_shell);
-                g_object_notify (G_OBJECT (user), "shell");
-        }
-
-        update_icon_monitor (user);
-
-        g_object_thaw_notify (G_OBJECT (user));
-}
-
-/**
- * _gdm_user_icon_changed:
- * @user: the user to emit the signal for.
- *
- * Emits the "icon-changed" signal for @user.
- *
- * Since: 1.0
- **/
-void
-_gdm_user_icon_changed (GdmUser *user)
-{
-        g_return_if_fail (GDM_IS_USER (user));
+        g_free (user->display_name);
 
-        g_signal_emit (user, signals[ICON_CHANGED], 0);
+        (*G_OBJECT_CLASS (gdm_user_parent_class)->finalize) (object);
 }
 
-/**
- * gdm_user_get_uid:
- * @user: the user object to examine.
- *
- * Retrieves the ID of @user.
- *
- * Returns: a pointer to an array of characters which must not be modified or
- *  freed, or %NULL.
- *
- * Since: 1.0
- **/
-
 uid_t
 gdm_user_get_uid (GdmUser *user)
 {
         g_return_val_if_fail (GDM_IS_USER (user), -1);
 
-        return user->uid;
+        return user->props->uid;
 }
 
-/**
- * gdm_user_get_real_name:
- * @user: the user object to examine.
- *
- * Retrieves the display name of @user.
- *
- * Returns: a pointer to an array of characters which must not be modified or
- *  freed, or %NULL.
- *
- * Since: 1.0
- **/
-G_CONST_RETURN gchar *
+const gchar *
 gdm_user_get_real_name (GdmUser *user)
 {
         g_return_val_if_fail (GDM_IS_USER (user), NULL);
 
-        return (user->real_name ? user->real_name : user->user_name);
+        return user->props->real_name;
 }
 
-/**
- * gdm_user_get_display_name:
- * @user: the user object to examine.
- *
- * Retrieves the unique display name of @user.
- *
- * Returns: a pointer to an array of characters which must not be modified or
- *  freed, or %NULL.
- *
- * Since: 1.0
- **/
-G_CONST_RETURN gchar *
+const gchar *
 gdm_user_get_display_name (GdmUser *user)
 {
         g_return_val_if_fail (GDM_IS_USER (user), NULL);
 
-        return (user->display_name ? user->display_name
-                : gdm_user_get_real_name (user));
+       return user->display_name ? user->display_name
+                                 : user->props->real_name;
 }
 
-/**
- * gdm_user_get_user_name:
- * @user: the user object to examine.
- *
- * Retrieves the login name of @user.
- *
- * Returns: a pointer to an array of characters which must not be modified or
- *  freed, or %NULL.
- *
- * Since: 1.0
- **/
-
-G_CONST_RETURN gchar *
+const gchar *
 gdm_user_get_user_name (GdmUser *user)
 {
         g_return_val_if_fail (GDM_IS_USER (user), NULL);
 
-        return user->user_name;
+        return user->props->user_name;
 }
 
-/**
- * gdm_user_get_home_directory:
- * @user: the user object to examine.
- *
- * Retrieves the home directory of @user.
- *
- * Returns: a pointer to an array of characters which must not be modified or
- *  freed, or %NULL.
- *
- * Since: 1.0
- **/
-
-G_CONST_RETURN gchar *
-gdm_user_get_home_directory (GdmUser *user)
+gint
+gdm_user_get_account_type (GdmUser *user)
 {
-        g_return_val_if_fail (GDM_IS_USER (user), NULL);
-
-        return user->home_dir;
-}
-
-/**
- * gdm_user_get_shell:
- * @user: the user object to examine.
- *
- * Retrieves the login shell of @user.
- *
- * Returns: a pointer to an array of characters which must not be modified or
- *  freed, or %NULL.
- *
- * Since: 1.0
- **/
-
-G_CONST_RETURN gchar *
-gdm_user_get_shell (GdmUser *user)
-{
-        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+        g_return_val_if_fail (GDM_IS_USER (user), 0);
 
-        return user->shell;
+        return user->props->account_type;
 }
 
 gulong
@@ -658,66 +302,10 @@
 {
         g_return_val_if_fail (GDM_IS_USER (user), 0);
 
-        return user->login_frequency;
+        return user->props->login_frequency;
 }
 
-/**
- * _gdm_user_show_full_display_name:
- * @user: the user object to examine.
- *
- * Updates the unique display name of @user to "Real Name (username)".
- *
- * Since: 1.0
- **/
-void
-_gdm_user_show_full_display_name (GdmUser *user)
-{
-        char *uniq_name;
-
-        g_return_if_fail (GDM_IS_USER (user));
-
-        if (user->real_name != NULL) {
-                uniq_name = g_strdup_printf ("%s (%s)",
-                                             user->real_name,
-                                             user->user_name);
-        } else {
-                uniq_name = NULL;
-        }
-
-        if ((user->real_name && !user->display_name) ||
-            (!user->real_name && user->display_name) ||
-            (user->real_name &&
-             user->display_name &&
-             strcmp (uniq_name, user->display_name) != 0)) {
-                g_free (user->display_name);
-                user->display_name = uniq_name;
-                g_object_notify (G_OBJECT (user), "display-name");
-        } else {
-                g_free (uniq_name);
-        }
-}
-
-/**
- * _gdm_user_show_short_display_name:
- * @user: the user object to examine.
- *
- * Resets the unique display name of @user.
- *
- * Since: 1.0
- **/
-void
-_gdm_user_show_short_display_name (GdmUser *user)
-{
-        g_return_if_fail (GDM_IS_USER (user));
-
-        if (user->display_name) {
-                g_free (user->display_name);
-                user->display_name = NULL;
-                g_object_notify (G_OBJECT (user), "display-name");
-        }
-}
-
-int
+gint
 gdm_user_collate (GdmUser *user1,
                   GdmUser *user2)
 {
